# Release 2.1.1 LTS - Change Log

Release 2.1.1 LTS is based on the 2.1 version of eXist-db. Like all LTS releases, it only contains hand-selected, tested bug fixes and improvements. It is fully compatible with 2.1. The most important changes are highlighted below:

### Critical issues
* Java service wrapper killed eXist if startup or shutdown took too long. This may damage the database.
* Remove old full text index by default. The old full text indexing module is known to cause performance as
well as stability issues. Sometimes an index was created by users unintentionally (resulting in a huge words.dbx in the data directory). We have thus decided to deactivate the module completely.
* Memory leak in lucene-based query functions

## Bug fixes
* Query optimizer failed to analyze enclosed expressions in attributes, default clauses of switch and typeswitch, as well as map constructors. This severly limited the performance of those expressions.
* Fixed map:remove
* Various security fixes

## Improvements
* Update EXPath HTTP Client library to improve streaming of large resources
* Added support for XQuery 3.0 dynamic namespace constructor.
* Make replication service more robust

## Detailed Change Log

Commit  | Date       | Message
+------ | +--------+ | ----------------------------------
d6b60f7 | 2013-11-26 | [bugfix] Wrong type set for map after calling map:remove, resulting in failing key lookups. (HEAD, origin/LTS-2.1.x, LTS-2.1.x) [Wolfgang Meier]
91cfc3f | 2013-11-22 | [bugfix] Module load path for XQuery module was overwritten to incorrect location. Should only be set from constructor. [Wolfgang Meier]
84709f1 | 2013-11-21 | [ignore] Test different ways to specify positional predicate. [Wolfgang Meier]
4544144 | 2013-11-18 | [bugfix] using numeric operator in filter expression causes error: $items/*[3 - 1]/target/start/number() [Wolfgang Meier]
ac0f218 | 2013-11-21 | * updated betterFORM version (bf-springBug-RC5) [Lars Windauer]
e2bed2d | 2013-11-05 | [bugfix] function lookups: ExternalModuleImpl.isReady always returned false, so a second lookup was done. Costs performance and may lead to NPE in dynamic function lookups. [Wolfgang Meier]
477ea42 | 2013-11-04 | [bugfix] Fix memory leak in lucene-based query functions (full-text and range index). [Wolfgang Meier]
b3bcff4 | 2013-10-31 | [extension] - update to betterFORM-5.0-RC4 (use installer version...) [Tobi Krebs]
94990a6 | 2013-10-31 | [extension] - update to betterFORM-5.0-RC4 [Tobi Krebs]
260d9d7 | 2013-10-29 | try to use current subject if eXist at same jvm [Dmitriy Shabanov]
e120602 | 2013-10-28 | [ignore] Fixed a typo in the build scripts (it's Git not GIT) [Joe Wicentowski]
97b6927 | 2013-10-28 | ignore additional optional jars: contentextraction (tika), svnkit, and icu4j [Joe Wicentowski]
cb5fc5c | 2013-10-27 | [bugfix] XQuery "keywords" (like "xquery" or "if") could not be used as namespace prefix in a module declaration. [Wolfgang Meier]
2f12a76 | 2013-10-27 | Fix wrapper startup for MacOSX 10.9 (Mavericks) [Dannes Wessels]
755d94c | 2013-10-16 | [bugfix] mail extension module: support binary mail attachments (using Java mail) whose data is already encoded in base64. Check specified mime type to see if the attachment is a binary or not. Previously only text was handled properly. [Wolfgang Meier]
e95ea1e | 2013-10-13 | [bugfix] A regression was introduced in Git commit dbb3035 which closed the input stream of HTTP Request bodies too early when they were binary values. This commit fixes that. [Adam Retter]
c7fe8f0 | 2013-10-13 | [bugfix] Pass-through for conversion to Item or Atomic [Adam Retter]
635292c | 2013-09-25 | Add the extension/modules/lib path to the IDEA project file. [Dr Josef Karthauser]
985ff47 | 2013-09-23 | Update macosx launcher scripts to use Oracle's appbundler for Java 7. Apple's bundler supports Java 6 only. [Wolfgang Meier]
51ba011 | 2013-09-23 | brokers leak because of exception at broker.flush call [Dmitriy Shabanov]
06e0f69 | 2013-09-19 | [bugfix] make dist-war target work again [Dannes Wessels]
01fc6aa | 2013-09-19 | Handle and report UnsupportedOperationExceptions to log for certain lucene field queries instead of just muffle the exception with potentially severe resource drainage as a consequence. [Leif-Jöran Olsson]
55dab18 | 2013-09-18 | Update intellij project: include webdav jars needed for run/debug configuration. [Wolfgang Meier]
985ca64 | 2013-09-15 | [bugfix] allow more StartupTriggers in conf.xml [Dannes Wessels]
7ff734d | 2013-09-14 | [testsuite] Get rid of old full text index throughout test suite. [Wolfgang Meier]
b761e54 | 2013-09-11 | [bugfix] allow parameters for startuptriggers [Dannes Wessels]
7f3e84b | 2013-09-10 | [bugfix] make debugger extension compile again [Dannes Wessels]
76a3d99 | 2013-09-06 | [lib-upgrade] upgrading to Java Service Wrapper Community Edition 3.5.20 - including 64bit windows support - synced scripts with originals [Dannes Wessels]
15131c4 | 2013-09-07 | Update copyright year [Dmitriy Shabanov]
0c11891 | 2013-09-05 | [bugfix] Security assertions were in the wrong places! User can now change own password [Adam Retter]
3cc3336 | 2013-08-31 | [feature] XQuery 3.0 dynamic namespace constructor: added more tests from XQ3 test suite and fixes; allow namespace constructor to appear before attribute constructors. [Wolfgang Meier]
26f4952 | 2013-08-31 | [feature] Added support for XQuery 3.0 dynamic namespace constructor. [Wolfgang Meier]
da773d8 | 2013-08-30 | Adding possibility to change CategoryLabelPositions in configuration, e.g. <categoryLabelPositions>UP_45</categoryLabelPositions> according to static fields UP_45, UP_90, DOWN_45 DOWN_90, default is STANDARD. [Leif-Jöran Olsson]
9daa058 | 2013-08-30 | Fixing plot type cast exception in use of MultiplePieChart [Leif-Jöran Olsson]
17bdc75 | 2013-08-29 | [bugfix] NPE in partial application of dynamic function call: fixed parameters need to be analyzed when creating the partial application. [Wolfgang Meier]
1714570 | 2013-08-21 | [bugfix] Do not NPE when calling restxq module function from not restxq context, rather error with RQDY0101 (origin/eXist-2.1.x) [Adam Retter]
f58b8d6 | 2013-08-18 | [lib-upgrade] upgraded commons-upload to 1.3 - move to java5 syntax - security fix - change log: http://commons.apache.org/proper/commons-fileupload/changes-report.html#a1.3 [Dannes Wessels]
1ad83c6 | 2013-08-18 | [feature] Added option to change serialization parameters for the WebDAV interface [Dannes Wessels]
39d0c16 | 2013-08-13 | [bugfix] wrapper kills eXist if it takes too long to start up or shut down, resulting in fatal errors and potential data loss. Broker pool used to send signals to the wrapper to keep it waiting, but recently this failed due to broker pool being synchronized during startup. Solution: implement Observable on StatusReporter, which runs in a separate thread and is not subject to broker pool locks. Make it notify observers every 500ms. [Wolfgang Meier]
118969c | 2013-08-05 | [feature] Use the Streaming capabilities of the new EXPath HTTP Client library [Adam Retter]
ba2b6b1 | 2013-08-05 | [feature] Updated to the latest EXPath HTTP Client with Streaming support [Adam Retter]
7c651d7 | 2013-08-06 | [bugfix] LDAP property setting to ensure 'objectSid' was always transferred as binary from the server was not always set. This previously broke AD LDAP loginsRevision 55d62d3 was just masking the problem. [Adam Retter]
32a38d4 | 2013-08-08 | [bugfix] corrected media type parameters for %rest:consumes %rest:produces, also now handles quality factors in HTTP Accept Headers [Adam Retter]
11efb04 | 2013-08-05 | [feature] Updated the AspectJ version [Adam Retter]
f959218 | 2013-08-04 | [ignore] Java5-ified construction of (LOG) messages [Dannes Wessels]
00e5507 | 2013-08-03 | [bugfix] eXist 2.0 depends on Servlet API 3.0 Change makes code consistent. Patch by Christian Mahnke [Dannes Wessels]
8188d53 | 2013-08-03 | [refactor] moved http dependency of http users out of the security core. Means you do not need javaxs.servlet dependency when embedding eXist [Adam Retter]
7a7d34a | 2013-08-03 | [bugfix] Make sure that all exceptions are logged in one way or the other even if just at the debugging level [feature] Introduced much more static typing to avoid unexpected problems [ignore] commented out unused code [Adam Retter]
ff39f2a | 2013-08-03 | Add optimizer tests to default tests. [Wolfgang Meier]
9fd9034 | 2013-08-03 | [bugfix] XQuery optimizer failed to analyze enclosed expressions in attributes, default clauses of switch and typeswitch, and map constructors. This severly limited the performance of those expressions. [Wolfgang Meier]
a1c5163 | 2013-08-03 | [testsuite] Add lots of tests to ensure that the query optimizer is properly analyzing all possible types of XQuery expressions. Extend XQuery test suite to support tests on index usage optimizations (if @test:stats annotation is present). [Wolfgang Meier]
3fc4f1f | 2013-08-01 | [bugfix] Fixed ENDERSED pathin windows scripts [Dannes Wessels]
3267f5f | 2013-07-30 | [ignore] Extended .gitignore Extended file to ignore more logfiles and build generated files [Dannes Wessels]
d17b68f | 2013-07-30 | [ignore] Adding more test related gitignores. [Leif-Jöran Olsson]
f06493f | 2013-07-29 | [ignore] Adding unit MB in the launcher configuration dialog to make it clear what the unit is. Synced form and java. [Leif-Jöran Olsson]
e1e13ea | 2013-07-28 | updated list of ignorable files/directories [Dannes Wessels]
bdda40a | 2013-07-29 | [ignore] Replacing use of subversion properties and svnkit libraries. [Leif-Jöran Olsson]
4d046cf | 2013-07-28 | Make replication extension more robust (receiver) - Fall-back to SYSTEM user/group when user/group does not exist for receiver - Create missing collections - Prevent re-replication of replication events [Dannes Wessels]